	.include	iocscall.mac
	.include	doscall.mac

	.cpu	68000

	.text
	.even

JOYPORT		equ	$e9a001
STBPORT		equ	$e9a007


*  f[^o (sampling rate = 62.5kHz) 
*  int Data_Out( unsigned char *buf, unsigned short size );
* 

	.xdef	_Data_Out
	.even

_Data_Out:
	clr.l	-(sp)			* X[p[oCU
	DOS	__SUPER
	addq.l	#4,sp
	move.l	d0,sspbuf

	lea.l	STBPORT,a1		* i8255
	move.b	#$92,(a1)

	lea.l	interrupt_flag(pc),a1	* 荞ݔptO
	clr.w	(a1)

	move.l	4(sp),d0		* 擾
	move.l	8(sp),d1
	move.l	d0,buf_address
	move.w	d1,buf_size

	ori.w	#$0700,sr		* 荞݋֎~
	lea.l	itout(pc),a1
	move.w	#2*256+6,d1		* 16us(62.5kHzŊ荞ݏ)
	IOCS	__TIMERDST

	andi.w	#$f8ff,sr		* 荞݋

	tst.l	d0
	beq	@f

	move.l	sspbuf,-(sp)		* [U
	DOS	__SUPER
	addq.l	#4,sp

	moveq.l	#1,d0			* łɊ荞݂ݒ肳Ă
	rts

@@:
	lea.l	interrupt_flag(pc),a1
@@:
	tst.w	(a1)			* ]I܂ő҂
	beq	@b

	ori.w	#$0700,sr		* 荞݋֎~
	suba.l	a1,a1
	IOCS	__TIMERDST
	andi.w	#$f8ff,sr		* 荞݋

	move.l	sspbuf,-(sp)		* [U
	DOS	__SUPER
	addq.l	#4,sp

	clr.l	d0
	rts

itout:					* 荞ݓ]
	movem.l	d0/a0-a2,-(sp)

	lea.l	buf_size(pc),a0		* c]oCg擾
	move.w	(a0),d0
	bne	@f

	lea.l	interrupt_flag(pc),a0	* ]I
	move.w	#$ff,(a0)
	bra	1f
@@:
	subq.l	#1,d0
	move.w	d0,(a0)

	lea.l	buf_address(pc),a0	* ]obt@AhX擾
	movea.l	(a0),a1

	lea.l	STBPORT,a2
	move.b	(a1)+,(a2)
	move.l	a1,(a0)
1:
	movem.l	(sp)+,d0/a0-a2
	rte


*  f[^ (sampling rate = 62.5kHz) 
*  int Data_In( unsigned char *buf, unsigned short size );
* 

	.xdef	_Data_In
	.even

_Data_In:
	clr.l	-(sp)			* X[p[oCU
	DOS	__SUPER
	addq.l	#4,sp
	move.l	d0,sspbuf

	lea.l	STBPORT,a1		* i8255
	move.b	#$92,(a1)

	lea.l	interrupt_flag(pc),a1	* 荞ݔptO
	clr.w	(a1)

	move.l	4(sp),d0		* 擾
	move.l	8(sp),d1
	move.l	d0,buf_address
	move.w	d1,buf_size

	ori.w	#$0700,sr		* 荞݋֎~
	lea.l	itin(pc),a1
	move.w	#2*256+6,d1		* 16us(62.5kHzŊ荞ݏ)
	IOCS	__TIMERDST

	lea.l	JOYPORT,a1		* ͂܂ő҂
@@:
	btst	#0,(a1)
	bne	@b

	andi.w	#$f8ff,sr		* 荞݋

	tst.l	d0
	beq	@f

	move.l	sspbuf,-(sp)		* [U
	DOS	__SUPER
	addq.l	#4,sp

	moveq.l	#1,d0			* łɊ荞݂ݒ肳Ă
	rts

@@:
	lea.l	interrupt_flag(pc),a1
@@:
	tst.w	(a1)			* ]I܂ő҂
	beq	@b

	ori.w	#$0700,sr		* 荞݋֎~
	suba.l	a1,a1
	IOCS	__TIMERDST
	andi.w	#$f8ff,sr		* 荞݋

	movea.l	4(sp),a0
	move.l	8(sp),d0
@@:					* ̓f[^direct-outpɕϊ
	andi.b	#$01,(a0)
	ori.b	#$08,(a0)+
	dbra	d0,@b

	move.l	sspbuf,-(sp)		* [U
	DOS	__SUPER
	addq.l	#4,sp

	clr.l	d0
	rts

itin:					* 荞ݓ]
	movem.l	d0/a0-a2,-(sp)

	lea.l	buf_size(pc),a0		* c]oCg擾
	move.w	(a0),d0
	bne	@f

	lea.l	interrupt_flag(pc),a0	* ]I
	move.w	#$ff,(a0)
	bra	1f
@@:
	subq.l	#1,d0
	move.w	d0,(a0)

	lea.l	buf_address(pc),a0	* ]obt@AhX擾
	movea.l	(a0),a1

	lea.l	JOYPORT,a2
	move.b	(a2),(a1)+
	move.l	a1,(a0)
1:
	movem.l	(sp)+,d0/a0-a2
	rte


*  o̓s(PC4=High) 
*  void Initialize_Outport( int c );
* 

	.xdef _Initialize_Outport
	.even

_Initialize_Outport:
	clr.l	-(sp)		* X[p[oCU
	DOS	__SUPER
	addq.l	#4,sp
	move.l	d0,sspbuf

	move.l	4(sp),d0

	lea.l	STBPORT,a1	* PC4 = H
	move.b	#$92,(a1)
	move.b	d0,(a1)

	move.l	sspbuf,-(sp)	* [U
	DOS	__SUPER
	addq.l	#4,sp

	rts


*    AԂ̌o   
* void vsync( void )
* 

	.xdef	_vsync
	.even

GPIP	equ	$e88001

_vsync:
	lea	GPIP,a1
	IOCS	__B_BPEEK
	btst.l	#4,d0
	beq	_vsync
vsync2:
	lea	GPIP,a1
	IOCS	__B_BPEEK
	btst.l	#4,d0
	bne	vsync2
	clr.l	d0
	rts

* 

	.data
	.even

sspbuf:					* ssp ۑobt@
	ds.l	1

interrupt_flag:				* 荞ݏIp
	ds.w	1

buf_size:				* ]oCg
	ds.w	1

buf_address:				* ]obt@AhX
	ds.l	1
